<?php

	/*
		@name: Payment paybylink.pl
		@last_update: 16/02/2020
		@verstion: 2.00
	*/

	include("../../../init.php");
	include("../../../includes/functions.php");
	include("../../../includes/gatewayfunctions.php");
	include("../../../includes/invoicefunctions.php");


	$gatewaymodule = "paybylink";
	$GATEWAY       = getGatewayVariables($gatewaymodule);

	if (!isset($GATEWAY["type"]))
		die("Module Not Activated");

	$response = file_get_contents('php://input');
    $response = json_decode($response, true);

    if(!isset($response['transactionId']) OR empty($response['transactionId'])) {
        echo 'not found transactionId';
        $error = true;
    }   

    if(!isset($response['control']) OR empty($response['control'])) {
        echo 'not found control';
        $error = true;
    }   

    if(!isset($response['email']) OR empty($response['email'])) {
        echo 'not found email';
        $error = true;
    }   

    if(!isset($response['amountPaid']) OR empty($response['amountPaid'])) {
        echo 'not found amountPaid';
        $error = true;
    }   

    if(!isset($response['notificationAttempt'])){
        echo 'not found notificationAttempt';
        $error = true;
    }  

    if(!isset($response['paymentType']) OR empty($response['paymentType'])) {
        echo 'not found paymentType';
        $error = true;
    }   

    if(!isset($response['apiVersion']) OR empty($response['apiVersion'])) {
        echo 'not found apiVersion';
        $error = true;
    }  

    if(!isset($error)) {

        $sign = sprintf("%s|%s|%s|%s|%.2f|%d|%s|%d", $GATEWAY['hash'], $response['transactionId'], $response['control'], $response['email'], $response['amountPaid'], $response['notificationAttempt'], $response['paymentType'], $response['apiVersion']);

            if(hash('sha256', $sign) != $response['signature']) {  
                echo 'BAD SIGNATURE';
                logTransaction($GATEWAY["name"], $response, "Unsuccessful");
            } else {    

            $invoiceid = checkCbInvoiceID($response['control'], $GATEWAY["name"]);

            # Successful
			addInvoicePayment($invoiceid, $response['control'], $response['amountPaid'], 0, $gatewaymodule, 123);
			logTransaction($GATEWAY["name"], $response, "Successful");

            header("HTTP/2.0 200 OK");
            echo 'OK';

        }
    }

